//Sweep8000.c Sweep sinusoid using table with 8000 points

#include "DSK6713_AIC23.h"	//codec-DSK support file
Uint32 fs=DSK6713_AIC23_FREQ_8KHZ;	//set sampling rate
#include "sine8000_table.h" 	         //one cycle with 8000 points
short start_freq = 100;                //initial frequency
short stop_freq = 3500;                //maximum frequency
short step_freq = 200;                 //increment/step frequency
short amp = 30;                        //amplitude 
short delay_msecs = 1000;              //# of msec at each frequency
short freq;							//variable frequency
short t;
short i = 0;

void main()
{
 comm_poll();                          //init DSK, codec, McBSP
 while(1)					   //infinite loop
  {
   for(freq=start_freq;freq<=stop_freq;freq+=step_freq) 
    {						   //step thru freqs
     for(t=0; t<8*delay_msecs; t++)    //output 8*delay_msecs samples   
      {                                // at each freq
       output_sample(amp*sine8000[i]); //output 
       i = (i + freq) % 8000;          //next sample is + freq in table
      }
    }
  }
}
 
