//bios_sine_ctrl.c Sine generation with DIP Switch control

#include "bios_sine_ctrlcfg.h"               //generated support file
#include "dsk6713.h"
#include "dsk6713_led.h"
#include "dsk6713_dip.h"
#include "dsk6713_aic23.h"                  	//codec-DSK support file
Uint32 fs=DSK6713_AIC23_FREQ_8KHZ;  			//set sampling rate

short sine_on = 0, loop = 0, gain = 10;
short sine_table[8] = {0,707,1000,707,0,-707,-1000,-707};

void sinegen()
{ 
    if (DSK6713_DIP_get(2) == 0)		//if sw#2 pressed
     {
		DSK6713_LED_on(2);				//turn on led#2
		while(++sine_on<5000)			//generate sine wave
		 {								//for 5 sec
		output_sample(sine_table[loop]*gain); //out with gain @ both channels
		if (++loop > 7) loop = 0;
		 }
		sine_on=0;
	  }
	DSK6713_LED_off(2);
}

void blinkLED0()
{
    DSK6713_LED_toggle(0);

    if (DSK6713_DIP_get(3) == 0)
        DSK6713_LED_on(3);
    else
        DSK6713_LED_off(3);
}

void main()
{
	comm_poll();
   DSK6713_LED_init();
   DSK6713_DIP_init();
}
