//RTDX_lv_sine.c Sine generation with RTDX using LabVIEW

#include "rtdx_lv_sinecfg.h"         					//generated by .cdb file
#include "dsk6713_aic23.h"                      	//codec-dsk support file
#include <rtdx.h>                                  // for rtdx support
Uint32 fs=DSK6713_AIC23_FREQ_16KHZ;           		//set sampling rate
short loop = 0;
short sin_table[8] = {0,707,1000,707,0,-707,-1000,-707};
int gain = 1;

RTDX_CreateInputChannel(control_channel);        	//create input channel

interrupt void c_int11()                       		//ISR set in .cdb
{
	output_sample(sin_table[loop]*gain);
   if (++loop > 7) loop = 0;
}
 
void main()
{
	comm_intr();   											//init codec,dsk,MCBSP
   RTDX_enableInput(&control_channel);             //enable input channel
   while(1)  													//infinite loop
	{
   if(!RTDX_channelBusy(&control_channel))         //if channel not busy
   	RTDX_read(&control_channel, &gain, sizeof(gain)); //read data from PC
	}
}
