//Sine generation with output to both LEFT and RIGHT channels

#include "dsk6713_aic23.h"	//codec-dsk support file
Uint32 fs=DSK6713_AIC23_FREQ_8KHZ;	//set sampling rate

#define LEFT  0
#define RIGHT 1
union {Uint32 combo; short channel[2];} AIC23_data; 

short loop = 0, gain = 10;
short sine_table[8] = {0,707,1000,707,0,-707,-1000,-707};//sine values

interrupt void c_int11()	//interrupt service routine 
{  
	AIC23_data.channel[RIGHT]=sine_table[loop]*gain; //for right channel;
	AIC23_data.channel[LEFT]=sine_table[loop]*gain; //for leftchannel;

	output_sample(AIC23_data.combo); //output to both channels 
	
	if (++loop > 7) loop = 0;		//reint table index if @ end of table                 			
} 

void main()					
{   
  	comm_intr();               //init DSK,codec,McBSP 
 	while(1) ;					//infinite loop
}            
 
